﻿CREATE DATABASE restricciones;
USE restricciones;
CREATE TABLE clientes (
  id int AUTO_INCREMENT,
  edad int,
  edad1 int,
  PRIMARY KEY(id)
  );

ALTER TABLE clientes ADD COLUMN edad1 int;

CREATE OR REPLACE VIEW vista1 AS
SELECT * FROM clientes WHERE edad>=0 AND edad1>edad
  WITH LOCAL CHECK OPTION;

TRUNCATE clientes;

INSERT IGNORE INTO vista1 VALUES
  (DEFAULT,-10,10),
  (DEFAULT,10,0),
  (DEFAULT,10,20);

SELECT * FROM vista1;
SELECT * FROM clientes;

CREATE TABLE ventas(
  id int AUTO_INCREMENT,
  cliente int,
  fecha date,
  cantidad int,
  PRIMARY KEY (id)
);

ALTER TABLE ventas
  ADD CONSTRAINT fkventasClientes FOREIGN KEY (cliente)
  REFERENCES clientes(id) ON DELETE CASCADE ON UPDATE CASCADE;

CREATE OR REPLACE VIEW vista2 AS
SELECT * FROM ventas
  WHERE fecha<NOW() AND cantidad BETWEEN 10 AND 100
  WITH LOCAL CHECK OPTION;

TRUNCATE ventas;

INSERT IGNORE INTO vista2 VALUES
  (DEFAULT,NULL,'2020/1/1',0),
  (DEFAULT,NULL,'2020/1/1',80),
  (DEFAULT,NULL,'2018/1/1',80);

SELECT * FROM ventas;

CREATE OR REPLACE VIEW vista3 AS
  SELECT * FROM ventas WHERE cantidad BETWEEN 10 AND 100
  WITH LOCAL CHECK OPTION;

CREATE OR REPLACE VIEW vista4 AS
  SELECT * FROM vista3 WHERE fecha<NOW()
  WITH LOCAL CHECK OPTION;

TRUNCATE ventas;

INSERT IGNORE INTO vista3 VALUES
  (DEFAULT,NULL,'2020/1/1',0),
  (DEFAULT,NULL,'2020/1/1',80),
  (DEFAULT,NULL,'2018/1/1',80);

SELECT * FROM ventas;

TRUNCATE ventas;

INSERT IGNORE INTO vista4 VALUES
  (DEFAULT,NULL,'2020/1/1',0),
  (DEFAULT,NULL,'2020/1/1',80),
  (DEFAULT,NULL,'2018/1/1',80),
  (DEFAULT,NULL,'2018/1/1',0);

SELECT * FROM ventas;

CREATE OR REPLACE VIEW vista5 AS
  SELECT * FROM vista3 WHERE fecha<NOW()
  WITH CASCADED CHECK OPTION;

TRUNCATE ventas;

INSERT IGNORE INTO vista5 VALUES
  (DEFAULT,NULL,'2020/1/1',0),
  (DEFAULT,NULL,'2020/1/1',80),
  (DEFAULT,NULL,'2018/1/1',80),
  (DEFAULT,NULL,'2018/1/1',0);

SELECT * FROM ventas;

ALTER TABLE clientes ADD COLUMN ventas int;

TRUNCATE ventas;

DELETE FROM clientes;

INSERT INTO clientes VALUES
  (2,40,45,0);

INSERT IGNORE INTO vista5 VALUES
  (DEFAULT,2,'2018/1/1',40),
  (DEFAULT,2,'2018/1/1',80);

UPDATE clientes JOIN(SELECT cliente,COUNT(*) total
  FROM ventas GROUP BY cliente) c1 ON clientes.id=cliente SET clientes.ventas=total;































